/*
 * ADC.h
 *
 * Created: 18.07.2012 21:42:52
 *  Author: admin
 */ 


#ifndef ADC_H_
#define ADC_H_
typedef enum{
	eADC_PRESCALER_2 = (0<<ADPS2)|(0<<ADPS1)|(1<<ADPS0),
	eADC_PRESCALER_4 = (0<<ADPS2)|(1<<ADPS1)|(0<<ADPS0),
	eADC_PRESCALER_8 = (0<<ADPS2)|(1<<ADPS1)|(1<<ADPS0),
	eADC_PRESCALER_16 = (1<<ADPS2)|(0<<ADPS1)|(0<<ADPS0),
	eADC_PRESCALER_32 = (1<<ADPS2)|(0<<ADPS1)|(1<<ADPS0),
	eADC_PRESCALER_64 = (1<<ADPS2)|(1<<ADPS1)|(0<<ADPS0),
	eADC_PRESCALER_128 = (1<<ADPS2)|(1<<ADPS1)|(1<<ADPS0),
	} eADC_PRESCALER;
	
typedef	enum{
	eADC_REFERENCE_AREF = (0<<REFS1)|(0<<REFS0),
	eADC_REFERENCE_AVCC = (0<<REFS1)|(1<<REFS0),
	eADC_REFERENCE_BANDGAP_1k1V = (1<<REFS1)|(1<<REFS0)
	} eADC_REFERENCE;
	
typedef enum{
	eADC_CHANNEL0 = ((0<<MUX3)|(0<<MUX2)|(0<<MUX1)|(0<<MUX0)),
	eADC_CHANNEL1 = ((0<<MUX3)|(0<<MUX2)|(0<<MUX1)|(0<<MUX1)),
	eADC_CHANNEL2 = ((0<<MUX3)|(0<<MUX2)|(1<<MUX1)|(0<<MUX0)),
	eADC_CHANNEL3 = ((0<<MUX3)|(0<<MUX2)|(1<<MUX1)|(1<<MUX0)),
	eADC_CHANNEL4 = ((0<<MUX3)|(1<<MUX2)|(0<<MUX1)|(0<<MUX0)),
	eADC_CHANNEL5 = ((0<<MUX3)|(1<<MUX2)|(0<<MUX1)|(1<<MUX0)),
	eADC_CHANNEL6 = ((0<<MUX3)|(1<<MUX2)|(1<<MUX1)|(0<<MUX0)),
	eADC_CHANNEL7 = ((0<<MUX3)|(1<<MUX2)|(1<<MUX1)|(1<<MUX0)),
	eADC_CHANNEL8 = ((1<<MUX3)|(0<<MUX2)|(0<<MUX1)|(0<<MUX0)),
	eADC_BANDGAP_1k1V = ((1<<MUX3)|(1<<MUX2)|(1<<MUX1)|(0<<MUX0)),
	eADC_GND = ((1<<MUX3)|(1<<MUX2)|(1<<MUX1)|(1<<MUX0))
} eADC_CHANNEL;		
	
	
#define ADC_StartConversion() (ADCSRA |= (1<<ADSC))
#define ADC_ClearIRQFlag()    (ADCSRA |= (1<<ADIF))

extern volatile uint16_t ADC_Sample;

void ADC_Init();
void ADC_Init_Bandgap();
void ADC_Enable();
void ADC_Disable();
void ADC_EnableAutoTrigger();
void ADC_DisableAutoTrigger();
void ADC_EnableInterrupt();
void ADC_DisableInterrupt();
void ADC_SetPrescaler(eADC_PRESCALER adc_prescaler);
uint8_t ADC_GetPrescaler();
void ADC_SetReference(eADC_REFERENCE adc_reference);
eADC_REFERENCE ADC_GetReference();
uint16_t ADC_SampleChannel(eADC_CHANNEL adc_channel);
void ADC_SetChannel(eADC_CHANNEL adc_channel);
uint16_t ADC_CH6();


#endif /* ADC_H_ */