
/*
 * Assembly1.s
 *
 * Created: 08.12.2012 14:26:50
 *  Author: admin
 */ 


//#define _SFR_ASM_COMPAT 1
//#define __SFR_OFFSET
#include <avr/io.h>

.section .text 
.global AsmSqrt

AsmSqrt:
#define MASK    R16
#define RESLOW  R24
#define RESHIGH R25
#define INLOW   R4
#define INHIGH  R5

	movw INLOW,RESLOW
	push MASK
	ldi MASK, 1<<7
	clr RESLOW
	LOOP4: add RESLOW, MASK
	mul RESLOW, RESLOW
	cp INLOW,R0		
	cpc INHIGH, R1
	brsh LB5				
	sub RESLOW, MASK		
	LB5:	lsr  MASK			
	brne LOOP4	
	pop MASK			
	clr R1
	ret


.section .text 
.global AsmLog2

AsmLog2: 
#define  ANSF  r2              //;Fractional Part of Answer
#define   ANS  r3              //;Integer Part of Answer
#define     A  r16             //;Original Value
#define     N  r20             //;Counter/Index
                    
        ldi A,100            ;Load Original Value
        ldi  N,7             ;Initial log2 Value 
        push A               ;Store Original Value
LOOP:   lsl A                ;Shift Left until a one falls out
        brcs FINI           ;
SKIP:   dec N                ;
        brne LOOP           ;
FINI:   mov ANS,N            ;Store the Integer Part of Answer
        mov ANSF,A           ;Store Fractional Part
        ldi A,177            ;Multiply by 177 then
MUL16x8:
		mul ANSF,A           ;divide by 256 by ignoring
        mov ANSF,R1          ;lowest byte of the result
        mul ANS,A            ;
        clr ANS              ;
        add ANSF,R0          ;
        adc ANS,R1           ;
        pop A                ;Restore Original Value
		ret
 
 .global AsmLog10_8
 .section .text
 AsmLog10_8:

#define  ANSF  R25            //;Fractional Part of Answer
#define   ANS  R24            //;Integer Part of Answer
#define     A  R16            //;Original Value
#define     N  R20            //;Counter/Index
		 mov A,ANS            ; Load Value. For GNU assembler the Value stored in R25:R24 
		 LDI  N,7             ;Initial log2 Value 
         PUSH A               ;Store Original Value
LOOP1:   LSL A                ;Shift Left until a one falls out
         BRCS FINI1           ;
         DEC N                ;
         BRNE LOOP1           ;
FINI1:   MOV ANS,N            ;Store the Integer Part of Answer
         MOV ANSF,A           ;Store Fractional Part
         LDI A,77             ;Multiply by 77 then
MUL16x8_1: MUL ANSF,A           ;divide by 256 by ignoring
           MOV ANSF,R1          ;lowest byte of the result
           MUL ANS,A            ;
           CLR ANS              ;
           ADD ANSF,R0          ;
           ADC ANS,R1           ;
		   clr R1				 ; GNU requires R1 must be set zero before return
           POP A                ;Restore Original Value
		   ret

 .global AsmLog10
 .section .text

 AsmLog10:
#define   ANSF  R24              //Fractional Part of Answer
#define    ANS  R25              //Integer Part of Answer
#define   TMP1  R4              //Workspace
#define   TMP2  R5              
#define   TMP3  R6              
#define   TMP4  R7              
#define   ZERO  R10             //Hold Zero
#define     AL  R16             //Original Value
#define     AH  r17             
#define      N  r20             //Counter/Index
		mov AL,ANSF
        //ldi AL,lo8(100)    ;Load Original Value
		mov AH,ANS
        //LDI AH,hi8(100)   ;
        LDI  N,15            ;Initial log2 Value 
        PUSH AL              ;Store Original Value
        PUSH AH              ;
LOOP2:   LSL AL               ;Shift Left until a one falls out
        ROL AH               ;
         BRCS FINI2           ;
SKIP2:   DEC N                ;
         BRNE LOOP2           ;
FINI2:   MOV ANS,N            ;Store the Integer Part of Answer 
        MOV ANSF,AH          ;Store Fractional Part
        LDI AL,lo8(19728)    ;Multiply by 19728
        LDI AH,hi8(19728)   ;Then divide by 65536 by ignoring
MUL16x16:                    ;the two lowest bytes
        CLR ZERO             ;
        MUL ANS,AH           ;
        MOVW TMP3,r0 ;
        MUL ANSF,AL          ;
        MOVW TMP1,R0 ;
        MUL ANS,AL           ;
        ADD TMP2,R0          ;
        ADC TMP3,R1          ;
        ADC TMP4,ZERO        ;
        MUL ANSF,AH          ;
        ADD TMP2,R0          ;
        ADC TMP3,R1          ;
        ADC TMP4,ZERO        ;
		mov ANS,TMP3
		mov ANSF,TMP4
        //MOVW ANSF,TMP3 ;Store Answer
        POP AH               ;Restore Original Value
        POP AL               ;
		clr R1				 ; GNU requires R1 must set to zero before return
		ret


//***********************************************
//
//***********************************************
 .global AsmLogMagnitude
 .section .text
//defines for SQRT
#define MASK    R16
#define RESLOW  R24
#define RESHIGH R25
#define INLOW   R4
#define INHIGH  R5
//defines for LOG
#define   ANSF  R24              //Fractional Part of Answer
#define    ANS  R25              //Integer Part of Answer
#define   TMP1  R4              //Workspace
#define   TMP2  R5              
#define   TMP3  R6              
#define   TMP4  R7              
#define   ZERO  R10             //Hold Zero
#define     AL  R16             //Original Value
#define     AH  r17             
#define      N  r20             //Counter/Index

AsmLogMagnitude:
SQRT:			;Square root
				movw INLOW,RESLOW
				push MASK
				ldi MASK, 1<<7
				clr RESLOW
	SQRT_LP1: 
				add RESLOW, MASK
				mul RESLOW, RESLOW
				cp INLOW,R0		
				cpc INHIGH, R1
				brsh SQRT_LP2				
				sub RESLOW, MASK		
	SQRT_LP2:
				lsr  MASK			
				brne SQRT_LP2	
				pop MASK			
				clr R1
LOG10:			;LOG10
				mov AL,RESLOW
				mov AH,RESHIGH
				LDI  N,15            ;Initial log2 Value 
				PUSH AL              ;Store Original Value
				PUSH AH              ;
	LOG_LP1:	
				LSL AL               ;Shift Left until a one falls out
				ROL AH               ;
				BRCS LOG_FIN         ;
	LOG_SKIP:	
				DEC N                ;
				BRNE LOG_LP1           ;
	LOG_FIN:	
				MOV ANS,N            ;Store the Integer Part of Answer 
				MOV ANSF,AH          ;Store Fractional Part
				LDI AL,lo8(19728)    ;Multiply by 19728
				LDI AH,hi8(19728)   ;Then divide by 65536 by ignoring
	LOG_MUL16x16:                    ;the two lowest bytes
				CLR ZERO             ;
				MUL ANS,AH           ;
				MOVW TMP3,r0 ;
				MUL ANSF,AL          ;
				MOVW TMP1,R0 ;
				MUL ANS,AL           ;
				ADD TMP2,R0          ;
				ADC TMP3,R1          ;
				ADC TMP4,ZERO        ;
				MUL ANSF,AH          ;
				ADD TMP2,R0          ;
				ADC TMP3,R1          ;
				ADC TMP4,ZERO        ;
				mov ANS,TMP3
				mov ANSF,TMP4
				//MOVW ANSF,TMP3 ;Store Answer
				POP AH               ;Restore Original Value
				POP AL               ;
				clr R1				 ; GNU requires R1 must set to zero before return
				ret