
#include "Batterie.h"
#include "ADC.h"
#include <avr/io.h>

volatile uint16_t BATTERY_VOLTAGE_BUFF[(1<<BATTERY_VOLTAGE_ACC_AVG)];
volatile uint16_t BATTERY_VOLTAGE_AVG=0;
volatile uint16_t BATTERY_VOLTAGE_SUM=0;


//////////////////////////////////////////////////////////////////////////
//	Function: 	Add a new value to ring buffer for battery voltage
//              and update average value for battery voltage
//	Parameters: value
//	Return:		0
//
//	Note:
//
//
//////////////////////////////////////////////////////////////////////////
uint16_t BATTERY_AddToAvg()
{
	
	uint16_t adc6;
	static uint8_t index=0;
	
	ADC_SetReference(eADC_REFERENCE_BANDGAP_1k1V);
	ADC_SetChannel(eADC_CHANNEL6);
	ADC_SampleChannel(eADC_CHANNEL6);
	adc6=ADC_SampleChannel(eADC_CHANNEL6)*12;

	BATTERY_VOLTAGE_SUM -= BATTERY_VOLTAGE_BUFF[index];
	BATTERY_VOLTAGE_SUM += adc6;
	BATTERY_VOLTAGE_BUFF[index]=adc6;
	index++;
	//Calculate average
	BATTERY_VOLTAGE_AVG = BATTERY_VOLTAGE_SUM >> BATTERY_VOLTAGE_ACC_AVG;
	
	index %= (1<<BATTERY_VOLTAGE_ACC_AVG); //8 values
	
	return adc6;//BATTERY_VOLTAGE_AVG;
}

uint16_t BATTERY_GetVoltageAvg()
{
	return BATTERY_VOLTAGE_AVG;
}


void BATTERY_FillAvgBuffer()
{
	uint16_t cnt=65000;
	
	for(uint8_t i=0;i<=(1<<BATTERY_VOLTAGE_ACC_AVG)*10;i++)
	{
		BATTERY_AddToAvg();
	}
	//ADC_Disable();
}