/*
 * MMA7455L.h
 *
 * Created: 20.10.2012 17:05:31
 *  Author: admin
 */ 


#ifndef MMA7455L_H_
#define MMA7455L_H_

#define MM7455L_RW  7
#define MM7455L_MAX_ADDR  0x1E
#define MMA7455L_SPI_DUMMY 0xaa

//10 Bit output X low
#define MM7455L_REG_XOUTL  0x00
//10 Bit output X high
#define MM7455L_REG_XOUTH  0x01
//10 Bit output y low
#define MM7455L_REG_YOUTL  0x02
//10 Bit output y high
#define MM7455L_REG_YOUTL  0x03
//10 Bit output z low
#define MM7455L_REG_ZOUTL  0x04
//10 Bit output z high
#define MM7455L_REG_ZOUTL  0x05
//8 Bit output X
#define MM7455L_REG_XOUT8  0x06
//8 Bit output y
#define MM7455L_REG_YOUT8  0x07
//8 Bit output z
#define MM7455L_REG_ZOUT8  0x08
//Status register
#define MM7455L_REG_STATUS 0x09
//Detection source register
#define MM7455L_REG_SETSRC 0x0A
//Temperature output
#define MM7455L_REG_TOUT   0x0B
//I2C address
#define MM7455L_REG_I2CAD  0x0D
//User Information
#define MM7455L_REG_USRINF 0x0E
//Who am I
#define MM7455L_REG_WHOAMI 0x0F
//Offset drift x value low
#define MM7455L_REG_XOFFL  0x10
//Offset drift x value high
#define MM7455L_REG_XOFFH  0x11
//Offset drift y value low
#define MM7455L_REG_YOFFL  0x12
//Offset drift y value high
#define MM7455L_REG_YOFFH  0x13
//Offset drift z value low
#define MM7455L_REG_ZOFFL  0x14
//Offset drift z value high
#define MM7455L_REG_ZOFFH  0x15
//Mode control
#define MM7455L_REG_MCTL   0x16
//Interrupt latch reset
#define MM7455L_REG_INTRST 0x17
//Control 1
#define MM7455L_REG_CTL1   0x18
//Control 2
#define MM7455L_REG_CTL2   0x19
//Level detection threshold limit value
#define MM7455L_REG_LDTH   0x1A
//Pulse detection threshold limit value
#define MM7455L_REG_PDTH   0x1B
//Pulse duration value
#define MM7455L_REG_PW     0x1C
//latency time value
#define MM7455L_REG_LT     0x1D
//Time window for 2nd pulse value
#define MM7455L_REG_TW     0x1E
//Number of Avergae values for Acceleration in 2^N
#define MMA7455L_ACC_AVG    3  //8 values
//AUTOCALIBRATION PROCESS
#define MAX_CNT_RUNS 55
#define CAL_AVG_RUNS 10

extern volatile uint8_t MMA7455L_INT1_DRDY  ;
extern volatile uint8_t Xdata,Ydata,Zdata;
extern volatile int8_t X_latch,Y_latch,Z_latch;
extern volatile int8_t X_AVG;
extern volatile int8_t Y_AVG;
extern volatile int8_t Z_AVG;

void MMA7455L_Init();
void MMA7455L_SPI_Write(uint8_t reg, uint8_t data);
uint8_t MMA7455L_SPI_Read(uint8_t reg);
uint8_t MMA7455L_AutoCalibration(uint8_t intervall_max, uint8_t intervall_min, char direction_XYZ);
int8_t MMA7455L_GetZAvg();
int8_t MMA7455L_GetYAvg();
int8_t MMA7455L_GetXAvg();
int8_t MMA7455L_AddToAvg(uint8_t value);
uint8_t MMA7455L_FillAvgBuffer();

#endif /* MMA7455L_H_ */