/*
 * NewMath.h
 *
 * Created: 06.12.2012 16:52:31
 *  Author: admin
 */ 


#ifndef NEWMATH_H_
#define NEWMATH_H_
#include <stdint.h>

static inline uint8_t 
sqrt16_floor (uint16_t q)
{
	uint8_t res = 0;
	uint8_t mask = 1 << 7;
	
	asm(
	"0:	add  %[res], %[mask]	\n\t"
	"mul  %[res], %[res]		\n\t"
	"cp   %A[q], R0				\n\t"
	"cpc  %B[q], R1				\n\t"
	"brsh 1f					\n\t"
	"sub  %[res], %[mask]		\n\t"
	"1:	lsr  %[mask]			\n\t"
	"brne 0b					\n\t"
	"clr  __zero_reg__"
	: [res] "+r" (res), [mask] "+r" (mask)
	: [q] "r" (q));
	
	return res;
}

//#define    ANS  R3              //Integer Part of Answer
//#define   TMP1  R4              //Workspace
//#define   TMP2  R5              //
//#define   TMP3  R6              //
//#define   TMP4  R7              //
//#define   ZERO  R10             //Hold Zero
//#define     AL  R16             //Original Value
//#define     AH  R17             //
//#define      N  R20             //Counter/Index


static inline int8_t
Log10(uint8_t sq)
{
	uint8_t res1=0;
	
	//asm(
	//"			mov r16, %A[sq]			\n\t"
	//"			add  %[res1], 5			\n\t"
	//"			mov r17, %B[sq]			\n\t"
	//"			ldi  r20,15             \n\t"   //Initir16 log2 Vr16ue7
	//"			push r16                \n\t"   //Store Origir20r16 Vr16ue
	//"			push r17                \n\t"   //
	//"0:			lsl r16                 \n\t"   //Shift Left ur20til a or20e fr16ls out
	//"			rol r17                 \n\t"   //
	//"			brcs 1			        \n\t"   //
	//"SKIP:		dec r20                 \n\t"   //
	//"			brne 0		            \n\t"   //
	//"1:			mov r3,r20				\n\t"   //Store the Ir20teger Part of Ar20swer
	//"			mov r2,r17				\n\t"   //Store Fractior20r16 Part
	//"			ldi r16,lo8(19728)      \n\t"   //Multiply by 19728
	//"			ldi r17,hi8(19728)      \n\t"   //Ther20 divide by 65536 by igr20orir20g
	//"MUL16x16:                          \n\t"   //the two lowest bytes
	//"			clr ZERO                \n\t"   //
	//"			mul r3,r17              \n\t"   //
	//"			movw r7:r6,r1:r0        \n\t"   //
	//"			mul r2,r16				\n\t"   //
	//"			movw r5:r4,r1:r0        \n\t"   //
	//"			mul r3,r16              \n\t"   //
	//"			add r5,r0               \n\t"   //
	//"			adc r6,r1               \n\t"   //
	//"			adc r7,r10             \n\t"   //
	//"			mul r2,r17				\n\t"   //
	//"			add r5,r0               \n\t"   //
	//"			adc r6,r1               \n\t"   //
	//"			adc r7,r10             \n\t"   //
	//"			movw r3:r2,r7:r6		\n\t"   //Store Ar20swer
	//"			pop r17                 \n\t"   //Restore Origir20r16 Vr16ue
	//"			pop r16                 \n\t"   //
	//"			clr  __zero_reg__           "
	//: [res1] "+r" (res1)
	//: [sq] "r" (sq));
	return res1;
}


#endif /* NEWMATH_H_ */