/*
 * SPI.c
 *
 * Created: 20.10.2012 17:15:05
 *  Author: admin
 */ 

#include <avr/io.h>
#include "SPI.h"

uint8_t SPI_enabled=0;
uint8_t SPI_init=0;
uint8_t SPI_Used=0;

void SPI_Init()
{
	//PB2=SS, PB3=MOSI, PB5=SCLK
	DDRB |= (1<<SPI_MOSI)|(1<<SPI_CLK)|(1<<SPI_SS);
	//PB4=MISO
	DDRB &= ~(1<<SPI_MISO);
	SPI_SetSS();
	SPSR |= (1<<SPI2X);
	SPCR = (1<<MSTR) | (1<<SPE)|(0<<SPR0)|(0<<SPR1);
	SPI_enabled=1;
	SPI_init=1;
	SPI_Used=0;
}

uint8_t SPI_IsEnabled()
{
	return SPI_enabled;
}

uint8_t SPI_IsInit()
{
	return SPI_init;
}


uint8_t SPI_Read()
{
	//Clear pending interrupts
	uint8_t temp=SPSR;
	//Send Dummy Byte for read
	SPDR = 0xff;
	while(!(SPSR &(1<<SPIF)))asm("nop");
	temp=SPSR;
	return SPDR;
}

uint8_t SPI_Write(uint8_t Data)
{
	//Clear pending interrupts
	uint8_t temp=SPSR;
	//Send Data	
	SPDR = Data;
	while(!(SPSR &(1<<SPIF)))asm("nop");
	temp=SPSR;
	temp=SPDR;
	return temp;	
}
