// todo:
// convert the spi to software bitbang.
// write comments, tidy up code :)

//#include "SuperBall.h"
#include "Goertzel.h"
#include "Timer.h"
#include <math.h>
#include "UART.h"
#include "MMA7455L.h"
#include <float.h>
#include "NewMath.h"
#include "SPI.h"
#include "RN42.h"
#include "TLC5947.h"
#include "ADC.h"
#include "Batterie.h"
#include "Switch.h"
#include "settings.h"
#include <avr/eeprom.h>
#include <avr/delay.h>

#define MAX(a, b)  (((a) > (b)) ? (a) : (b))

int gCount = 0;
int gMode = 0;

void setup_scroll(void);
void loop_scroll(void);




int main(void)
 {
	char sBuffer[20];
	uint16_t temp=0;	
	int16_t result[SUPERBALL_COLUMNS];
	uint16_t battery_voltage=0;
	uint8_t Setup_Mode_Flash=0;
	
	uint16_t *p_eeprom_addr=0;
	uint16_t eeprom_addr=0;
	uint8_t mode_auto=0;
	uint8_t mode_temp=0;
	uint8_t mode_old=0;


	//eeprom_addr = EEPROM_MODE_START;
	//for(temp=0;temp<NUM_OF_ANIMATIONS;temp++)
	//{
		//eeprom_write_word((uint16_t*)eeprom_addr, 0x000a);
		//eeprom_addr+=2;
		//eeprom_write_word((uint16_t*)eeprom_addr, 0x0002);
		//eeprom_addr+=2;
	//}


	//Read last mode from EEPROM
	//eeprom_write_word((uint16_t)EEPROM_LAST_MODE, 0xaa);
	mode=eeprom_read_word((uint16_t*)EEPROM_LAST_MODE);
	if(mode > NUM_OF_ANIMATIONS)mode=0;
	
	//Read Values for brightness and speed from eeprom
	*p_eeprom_addr=EEPROM_MODE_START;
	eeprom_addr = EEPROM_MODE_START;
	for(temp=0;temp<NUM_OF_ANIMATIONS;temp++)
	{
		a_brightness[temp]=eeprom_read_word((uint16_t*)eeprom_addr);
		if(a_brightness[temp]>BRIGHTNESS_MAX)a_brightness[temp]=BRIGHTNESS_MAX;
		eeprom_addr+=2;
		a_speed[temp]=eeprom_read_word((uint16_t*)eeprom_addr);		
		eeprom_addr+=2;
	}

	
	//Set Default Brightness 
	//SetBrightness(BRIGHTNESS_DEFAULT);
	//SetBrightness(brightness);
	
	//Fill Buffer for Battery Voltage Measurement
	BATTERY_FillAvgBuffer();
	
	//Short delay for startup peripherals
	_delay_ms(1000);
	sei();
	//Init UART
	USART_init1(38400);
	
	//while(1)USART_putstring("Hallo\r\n");
	//Init bluetooth modul rn42
	RN42_Init();

	//Init SPI-Bus
	SPI_Init();
	
	//Init LED Driver
	LED_Init(GetBrightness());
	

	//Init G-Sensor MMA7455L
	MMA7455L_Init();
	//Disable I2C
	MMA7455L_SPI_Write(MM7455L_REG_I2CAD,0x9D); //4 Wire Mode Set up in the Accelerometer
	temp=MMA7455L_SPI_Read(MM7455L_REG_I2CAD); // Read back the value that has been set for the Mode
	//Set up sensor for SPI 3 Wire Mode or 4 Wire Mode by writing to SPI3W in Register $16
	MMA7455L_SPI_Write(MM7455L_REG_MCTL,0x05); //4 Wire Mode Set up in the Accelerometer
	temp=MMA7455L_SPI_Read(MM7455L_REG_MCTL); // Read back the value that has been set for the Mode
	temp=MMA7455L_SPI_Read(MM7455L_REG_STATUS);
	//Autocalibrate MMA7455L. Values in the range of +/-2 are accepted as zero
	temp=MMA7455L_AutoCalibration(2,-2,'y');
	//Fill Average Buffer
	MMA7455L_FillAvgBuffer();

	
	// Use PIN PINC5 for debug
	DDRC |= 1<<PINC5;
	PORTC &= ~(1<<PINC5);
	
	//Init Brightness Key
	Bright_Key_Init();
	//Init Mode Key
	Mode_Key_Init();
	//Enable global interrupts
	//sei();
	
	//Send greeting...
	USART_putstring("Hello, greetings from Blinky Ball1..\r\n");//_delay_ms(50);
	//UART_SendString("Hello, greetings from Blinky Ball..\r\n");//_delay_ms(50);
	
	//ADC_Init_Bandgap();

	Clear(0);
	WriteLEDArray1(NUM_TLC5947,1);

	#if(0)  //For Test purpose only
	for (;;)
	{		
		#if(1) //UART Frame Ready
		if(UART_FrameFinished==1)
		{
			for(uint8_t f=1;f<SUPERBALL_LED_PER_COLUMN;f+=2)
			{
				SetColumnLedRangeOn(0,0,UART_FrameBuffer[0]-UART_FrameBuffer[0]/f,255,1,0);
				SetColumnLedRangeOn(1,0,UART_FrameBuffer[1]-UART_FrameBuffer[1]/f,255,0,0);
				SetColumnLedRangeOn(2,0,UART_FrameBuffer[2]-UART_FrameBuffer[2]/f,255,0,0);
				SetColumnLedRangeOn(3,0,UART_FrameBuffer[3]-UART_FrameBuffer[3]/f,255,0,0);
				SetColumnLedRangeOn(4,0,UART_FrameBuffer[4]-UART_FrameBuffer[4]/f,255,0,0);
				SetColumnLedRangeOn(5,0,UART_FrameBuffer[5]-UART_FrameBuffer[5]/f,255,0,0);
				SetColumnLedRangeOn(6,0,UART_FrameBuffer[6]-UART_FrameBuffer[6]/f,255,0,0);
				SetColumnLedRangeOn(7,0,UART_FrameBuffer[7]-UART_FrameBuffer[7]/f,255,0,0);
				SetColumnLedRangeOn(8,0,UART_FrameBuffer[8]-UART_FrameBuffer[8]/f,255,0,0);
				SetColumnLedRangeOn(9,0,UART_FrameBuffer[9]-UART_FrameBuffer[9]/f,255,0,1);
				//SetColumnLedRangeOn(10,0,UART_FrameBuffer[10]-UART_FrameBuffer[10]/f,255,0,1);
				//SetColumnLedRangeOn(8,0,UART_FrameBuffer[8]-UART_FrameBuffer[8]/f,255,0,1);

			}			
			UART_FrameFinished=0;
		}
		#endif
	}
	#endif

	//Clear(BRIGHTNESS_DEFAULT);
	Clear(GetBrightness());
	WriteLEDArray1(NUM_TLC5947,1);
      
	ADC_Init();
	ADC_SetReference(eADC_REFERENCE_AVCC);
	ADC_SetChannel(eADC_CHANNEL7);
	Timer0_Init();
	Timer0_Start(eTimer0_Frequence_8KHz);
	Timer1_Init();
	Timer1_Start(eTimer1_Frequence_50Hz);
	Goertzel_Enable=1;	
	Goertzel_Count=0;  
	gain_calc=1;   

	while( 1 )					// Loop Here
	{	

		if(mode_auto==0)mode_temp=GetMode();	
		#if(1) //switch-mode-loop
		switch(mode_temp)
		{	
			case 0:	
				//Start Goertzel
				#if(1) //Goertzel Buffer filled
				//if(GetSetupMode()==SETUP_MODE_DISABLE)
				//{
					//brightness=a_brightness[mode_temp];
					//tim1_delay=a_speed[mode_temp];
					//eeprom_write_word((uint16_t*)EEPROM_LAST_MODE,mode_temp);
				//}
				
				//if(Goertzel_Enable==0)
				//{
					//Timer1_Stop();
					//Goertzel_Enable=1;
					//Goertzel_Count=0;
					//ADC_SetReference(eADC_REFERENCE_AVCC);
					//ADC_SetChannel(eADC_CHANNEL7);
					//Timer0_Start(eTimer0_Frequence_8KHz);
				//}
				
				if(GoertzelBufferFilled)
				{
					cli();

					//Gain Control
					//GoertzelGainControl(&GoertzelBuffer[0]);
					//Filter
					result[0]=GoertzelFilter1(COSINE_40,&GoertzelBuffer[0]);
					result[1]=GoertzelFilter1(COSINE_63,&GoertzelBuffer[0]);
					result[2]=GoertzelFilter1(COSINE_98,&GoertzelBuffer[0]);
					result[3]=GoertzelFilter1(COSINE_160,&GoertzelBuffer[0]);
					result[4]=GoertzelFilter1(COSINE_250,&GoertzelBuffer[0]);
					result[5]=GoertzelFilter1(COSINE_400,&GoertzelBuffer[0]);
					result[6]=GoertzelFilter1(COSINE_625,&GoertzelBuffer[0]);
					result[7]=GoertzelFilter1(COSINE_1000,&GoertzelBuffer[0]);
					result[8]=GoertzelFilter1(COSINE_1500,&GoertzelBuffer[0]);
					result[9]=GoertzelFilter1(COSINE_1800,&GoertzelBuffer[0]);
					result[10]=GoertzelFilter1(COSINE_2000,&GoertzelBuffer[0]);
					result[11]=GoertzelFilter1(COSINE_2500,&GoertzelBuffer[0]);
					result[12]=GoertzelFilter1(COSINE_3000,&GoertzelBuffer[0]);
					result[13]=GoertzelFilter1(COSINE_3200,&GoertzelBuffer[0]);
					result[14]=GoertzelFilter1(COSINE_3800,&GoertzelBuffer[0]);

					//Output
					for(uint8_t f=1;f<SUPERBALL_LED_PER_COLUMN;f+=10)
					{				
						SetColumnLedRangeOn(0,0,result[0]-result[0]/f,GetBrightness(),1,0);
						SetColumnLedRangeOn(1,0,result[1]-result[1]/f,GetBrightness(),0,0);
						SetColumnLedRangeOn(2,0,result[2]-result[2]/f,GetBrightness(),0,0);
						SetColumnLedRangeOn(3,0,result[3]-result[3]/f,GetBrightness(),0,0);
						SetColumnLedRangeOn(4,0,result[4]-result[4]/f,GetBrightness(),0,0);
						SetColumnLedRangeOn(5,0,result[5]-result[5]/f,GetBrightness(),0,0);
						SetColumnLedRangeOn(6,0,result[6]-result[6]/f,GetBrightness(),0,0);
						SetColumnLedRangeOn(7,0,result[7]-result[7]/f,GetBrightness(),0,0);
						SetColumnLedRangeOn(8,0,result[8]-result[8]/f,GetBrightness(),0,0);
						SetColumnLedRangeOn(9,0,result[9]-result[9]/f,GetBrightness(),0,0);
						SetColumnLedRangeOn(10,0,result[10]-result[10]/f,GetBrightness(),0,0);
						SetColumnLedRangeOn(11,0,result[11]-result[11]/f,GetBrightness(),0,0);
						SetColumnLedRangeOn(12,0,result[12]-result[12]/f,GetBrightness(),0,0);
						SetColumnLedRangeOn(13,0,result[13]-result[13]/f,GetBrightness(),0,0);
						SetColumnLedRangeOn(14,0,result[14]-result[14]/f,GetBrightness(),0,1);
					}
					Goertzel_Count=0;
					Goertzel_Complete=0;
					GoertzelBufferFilled=0;
					gain_calc=1;
					Goertzel_Enable=1;
					//Timer0_Stop();
					sei();
					//Timer1_Start(eTimer1_Frequence_50Hz);
					//USART_send('G');
				}
				#endif //Goertzel Buffer filled
			break;
		
			case 1:
				#if(1) //MM7455 INT1 Data Ready, showhorizontal acceraltion circles
				cli();
				if(GetSetupMode()==SETUP_MODE_DISABLE)
				{
					brightness=a_brightness[mode_temp];
					tim1_delay=a_speed[mode_temp];
					eeprom_write_word((uint16_t*)EEPROM_LAST_MODE,mode_temp);
				}
				if((PINB & (1<<PINB1)))
				{
					//PORTC |= (1<<PINC5);
					MMA7455L_AddToAvg(0);
					PORTC |= (1<<PINC5);
					//sprintf(sBuffer,".start%3.2f;%3.2f;%3.2f;%3.2f.end\n\r",X*0.0156,Y*0.0156,Z*0.0156,(float)ADC_CH6());
					//sprintf(sBuffer,".start%3d;%3d;%3d;%3d.end\n\r",MMA7455L_GetXAvg(),MMA7455L_GetYAvg(),MMA7455L_GetZAvg(),UART_GetBufferFill());
					sprintf(sBuffer,".start%3d;%3d;%3d;%3d.end\n\r",0,0,0,0);
					USART_putstring(&sBuffer);
					//UART_SendString(&sBuffer);
					MMA7455L_INT1_DRDY=0;					
					PORTC &= ~(1<<PINC5);
					SetRowFullOn(12-(MMA7455L_GetYAvg()-0x3f)/10,GetBrightness(),1,1);	
			
				}
				sei();
				#endif //MM7455 INT1 Data Ready
			break;
		
			case 2:	
				#if(1) //running columns
				if(GetSetupMode()==SETUP_MODE_DISABLE)
				{
					brightness=a_brightness[mode_temp];
					tim1_delay=a_speed[mode_temp];
					eeprom_write_word((uint16_t*)EEPROM_LAST_MODE,mode_temp);
				}
				for(uint8_t i=0;i<16;i++)
				{
					cli();
					SetColumnFullOn(i,GetBrightness(),1,1);
					sei();
					Timer1_IRQ_Delay();
				}
				
				#endif //running columns
			break;
		
			case 3:
				#if(1) //vertial circles
				if(GetSetupMode()==SETUP_MODE_DISABLE)
				{
					brightness=a_brightness[mode_temp];
					tim1_delay=a_speed[mode_temp];
					eeprom_write_word((uint16_t*)EEPROM_LAST_MODE,mode_temp);
				}				
				for(uint8_t i=0;i<8;i++)
				{
					cli();
					SetColumnFullOn(i,GetBrightness(),1,0);
					SetColumnFullOn(i+8,GetBrightness(),0,1);
					sei();
					Timer1_IRQ_Delay();
				}
				#endif //vertical circles
			break;
		
			case 4:
				#if(1) //horizontal circles
				if(GetSetupMode()==SETUP_MODE_DISABLE)
				{
					brightness=a_brightness[mode_temp];
					tim1_delay=a_speed[mode_temp];
					eeprom_write_word((uint16_t*)EEPROM_LAST_MODE,mode_temp);
				}					
				for(uint8_t i=0;i<24;i++)
				{
					cli();
					SetRowFullOn(i,GetBrightness(),1,1);
					sei();
					Timer1_IRQ_Delay();
				}
					
				#endif //horizontal circles
			break;
		
			case 5:
				#if(1) //single helix
				if(GetSetupMode()==SETUP_MODE_DISABLE)
				{
					brightness=a_brightness[mode_temp];
					tim1_delay=a_speed[mode_temp];
					eeprom_write_word((uint16_t*)EEPROM_LAST_MODE,mode_temp);
				}
				uint8_t column=0;
				for(uint8_t offs=0;offs<SUPERBALL_COLUMNS;offs++)
				{
					cli();
					column=offs;
					Clear(0);
					for(uint8_t row=0;row<SUPERBALL_LED_PER_COLUMN;row++)
					{
						if(column > SUPERBALL_COLUMNS-1) column=0;
						SetPoint1(column, row, GetBrightness(), 0, 0);
						column++;
						//column %= 15;
					}
					WriteLEDArray(SUPERBALL_COLUMNS);
					gain_calc=1;
					sei();
					Timer1_IRQ_Delay();
				}
					
				#endif //single helix
			break;
		
			case 6:
				#if(1) //single helix small
				if(GetSetupMode()==SETUP_MODE_DISABLE)
				{
					brightness=a_brightness[mode_temp];
					tim1_delay=a_speed[mode_temp];
					eeprom_write_word((uint16_t*)EEPROM_LAST_MODE,mode_temp);
				}					
				for(uint8_t offs=0;offs<SUPERBALL_COLUMNS;offs++)
				{
					cli();
					column=offs;
					Clear(0);
					for(uint8_t row=0;row<3*SUPERBALL_LED_PER_COLUMN;row++)
					{
						if(column > SUPERBALL_COLUMNS - 1 )column=0;
						SetPoint1(column, row/3, GetBrightness(), 0, 0);
						//SetPoint1(column, 23-row/2, 4095, 0, 0);
						column++;
						//column %= 15;
					}
					WriteLEDArray(SUPERBALL_COLUMNS);
					gain_calc=1;
					sei();
					Timer1_IRQ_Delay();
				}
					
				#endif //single helix small
			break;
		
			case 7:
				#if(1) //double parallel helix
				if(GetSetupMode()==SETUP_MODE_DISABLE)
				{
					brightness=a_brightness[mode_temp];
					tim1_delay=a_speed[mode_temp];
					eeprom_write_word((uint16_t*)EEPROM_LAST_MODE,mode_temp);
				}					
				for(uint8_t offs=0;offs<SUPERBALL_COLUMNS;offs++)
				{
					cli();
					column=offs;
					Clear(0);
					for(uint8_t row=0;row<SUPERBALL_LED_PER_COLUMN;row++)
					{
						if(column > SUPERBALL_COLUMNS-1) column=0;
						SetPoint1(column, row, GetBrightness(), 0, 0);
						SetPoint1((column+8)%15, row, GetBrightness(), 0, 0);
						column++;
						//column %= 15;
					}
					WriteLEDArray(SUPERBALL_COLUMNS);
					gain_calc=1;
					sei();
					Timer1_IRQ_Delay();
				}
					
				#endif //double parallel helix
			break;
		
			case 8:
				#if(1) //double helix
				if(GetSetupMode()==SETUP_MODE_DISABLE)
				{
					brightness=a_brightness[mode_temp];
					tim1_delay=a_speed[mode_temp];
					eeprom_write_word((uint16_t*)EEPROM_LAST_MODE,mode_temp);
				}
				for(uint8_t offs=0;offs<SUPERBALL_COLUMNS;offs++)
				{
					cli();
					column=offs;
					Clear(0);
					for(uint8_t row=0;row<SUPERBALL_LED_PER_COLUMN;row++)
					{
						if(column > SUPERBALL_COLUMNS-1) column=0;
						SetPoint1(column, row, GetBrightness(), 0, 0);
						SetPoint1(15- (column+7)%15, row, GetBrightness(), 0, 0);
						column++;
						//column %= 15;
					}
					WriteLEDArray(SUPERBALL_COLUMNS);
					gain_calc=1;
					sei();
					Timer1_IRQ_Delay();		
				}
				#endif //double helix	
			break;
		

			case 9:
				#if(1) // Ball full on
				cli();
				if(GetSetupMode()==SETUP_MODE_DISABLE)
				{
					brightness=a_brightness[mode_temp];
					tim1_delay=a_speed[mode_temp];
					eeprom_write_word((uint16_t*)EEPROM_LAST_MODE,mode_temp);
				}
				Clear(4095);
				WriteLEDArray1(NUM_TLC5947,1);
				sei();
				Timer1_IRQ_Delay();
				#endif //Ball full on
			break;
			case 10:
				#if(1) //show actual voltage
				cli();
				if(GetSetupMode()==SETUP_MODE_DISABLE)
				{
					brightness=a_brightness[mode_temp];
					tim1_delay=a_speed[mode_temp];
					eeprom_write_word((uint16_t*)EEPROM_LAST_MODE,mode_temp);
				}
				battery_voltage=(3350-BATTERY_GetVoltageAvg())/25;
				if(battery_voltage<0)battery_voltage=0;
				if(battery_voltage>23)battery_voltage=23;
				SetColumnLedRangeOn(0,0,24-battery_voltage,GetBrightness(),1,0);
				//for(temp=1;temp<15;temp++)SetColumnFullOn(temp,GetBrightness(),0,0);
				SetColumnFullOn(15,GetBrightness(),0,1);
				sei();
				Timer1_IRQ_Delay();
				#endif //show actual voltage
			break;
			case 11:
				#if(1) //Auto mode, show all anminations
				cli();
				if(GetSetupMode()==SETUP_MODE_DISABLE)
				{
					tim1_auto_delay=a_speed[mode];
					eeprom_write_word((uint16_t*)EEPROM_LAST_MODE,mode);
				}
				//short flash
				Clear(4095);
				WriteLEDArray1(NUM_TLC5947,1);
				_delay_ms(500);
				Clear(0);
				WriteLEDArray1(NUM_TLC5947,1);
				_delay_ms(500);
				Clear(4095);
				WriteLEDArray1(NUM_TLC5947,1);
				_delay_ms(500);
				Clear(0);
				WriteLEDArray1(NUM_TLC5947,1);
				_delay_ms(500);
				mode_temp=0;
				mode_auto=1;	
				mode_old=mode;	
				sei();
				#endif //show actual voltage
			break;
			//case 9:
				//#if(1) //polar coord
				//cli();
				//if(GetSetupMode()==SETUP_MODE_DISABLE)
				//{
					//brightness=a_brightness[mode];
					//tim1_delay=a_speed[mode];
					//eeprom_write_word((uint16_t*)EEPROM_LAST_MODE,mode);
				//}
				//Clear(0);
				//for(uint16_t theta=0;theta<=90;theta++)
				//{
					//SetPoint1((float)phi/22.5,(90.0+theta)/7.5,GetBrightness(),0,0);
				//}
							//
				//for(uint16_t phi=0;phi<=180;phi++)
				//{
				//}
				//WriteLEDArray(SUPERBALL_COLUMNS);
				//sei();
				//Timer1_IRQ_Delay();
				//#endif //polar coord
			//break;
		}	
		#endif //Swtich-mode-loop

		//Select how switch-mode-loop will be controlled (manually by switch or auto-toggle)
		
		if (mode_auto==1 && mode==mode_old)
		{
			if(tim1_auto_delay_done==1)
			{
				mode_temp++;
				//if(mode_temp==mode)mode_temp++;
				if(mode_temp==NUM_OF_ANIMATIONS-1)mode_temp=0;
				tim1_auto_delay_done=0;
			}
		}
		else if (mode_auto==1 && mode!=mode_old)
		{
			mode_auto=0;
			mode=0;
			mode_temp=mode;
		}

		
		#if(1) //Setup-mode
			switch(GetSetupMode())
			{
				case SETUP_MODE_DISABLE:
					if(Setup_Mode_Flash==1)
					{
						cli();
						//Write Values to eeprom
						//*p_eeprom_addr=EEPROM_MODE_START+mode;
						eeprom_addr=EEPROM_MODE_START+4*mode;
						a_brightness[mode]=brightness;
						eeprom_write_word((uint16_t)eeprom_addr, brightness );
						eeprom_addr+=2;
						if(mode==MODE_AUTO)a_speed[mode]=tim1_auto_delay;
						else a_speed[mode]=tim1_delay;
						eeprom_write_word((uint16_t)eeprom_addr, a_speed[mode]);
						//short flash to show leaving setup mode
						Clear(4095);
						WriteLEDArray1(NUM_TLC5947,1);
						_delay_ms(500);
						Clear(0);
						WriteLEDArray1(NUM_TLC5947,1);
						_delay_ms(500);	
						Clear(4095);
						WriteLEDArray1(NUM_TLC5947,1);
						_delay_ms(500);		
						//Read Values from eeprom
						//*p_eeprom_addr=EEPROM_MODE_START+mode;
						eeprom_addr=EEPROM_MODE_START+4*mode;
						a_brightness[mode]=eeprom_read_word((uint16_t)eeprom_addr);
						//brightness=a_brightness[mode];
						eeprom_addr+=2;
						a_speed[mode]=eeprom_read_word((uint16_t)eeprom_addr);	
						//brightness=a_brightness[mode]
						sprintf(sBuffer,"M=%2d, b=%4d, t=%4d\n\r",mode,a_brightness[mode], a_speed[mode]);
						sei();
						USART_putstring(&sBuffer);	
						Setup_Mode_Flash=0;
					}
					//Setup_Mode_Flash=0;
				break;
				case SETUP_MODE_SPEED:
					if(Setup_Mode_Flash==0)
					{
						cli();
						Clear(4095);
						WriteLEDArray1(NUM_TLC5947,1);
						_delay_ms(1000);
						sei();
						Setup_Mode_Flash=1;
					}
				break;
				case SETUP_MODE_BRIGHTNESS:
					if(Setup_Mode_Flash==0)
					{
						cli();
						Clear(4095);
						WriteLEDArray1(NUM_TLC5947,1);
						_delay_ms(1000);
						sei();
						Setup_Mode_Flash=1;
					}
				break;
			}
			
		#endif //Setup-mode
		
		#if(1) //Read Battery Voltage	
			//tim1_irq=1;
			if(tim1_irq==1)
			{
				cli();
				uint16_t adc6;
				adc6=BATTERY_AddToAvg();
				ADC_SetReference(eADC_REFERENCE_AVCC);
				ADC_SetChannel(eADC_CHANNEL7);
				//ADC_StartConversion();
				sprintf(sBuffer,"VOLT=%4d mV\n\r",adc6);
				USART_putstring(&sBuffer);
				tim1_irq=0;
				sei();
			}			
		#endif //Read Battery Voltage
		
		#if(1) //Turn off LED if Voltage is too low
			
			battery_voltage=BATTERY_GetVoltageAvg();
			
			if(battery_voltage<=BATTERY_VOLTAGE_LOW)
			{
				//Clear(0);
				//GetBrightness()=0;
				//WriteLEDArray1(NUM_TLC5947,1);				
			}
			else if (battery_voltage<=BATTERY_VOLTAGE_WARNING)
			{
				//SetMode(13);
			}
			else if(battery_voltage >= BATTERY_VOLTAGE_OK)
			{
				//Clear(BRIGHTNESS_DEFAULT);
				//GetBrightness()=BRIGHTNESS_DEFAULT;
				//WriteLEDArray1(NUM_TLC5947,1);
			}
		#endif //Turn off LED if Voltage is too low
		

			
		
	}
	return 0;
}

