#include "Switch.h"
#include "Timer.h"



void Bright_Key_Init()
{
	//Switch Pin to input
	BRIGHT_KEY_PORT_DIR &= ~(1<<BRIGHT_KEY_PIN);
	//Set Port High to enable Pullup (PUD must be enabled in MCUCR) !!!!
	BRIGHT_KEY_PORT |= (1<<BRIGHT_KEY_PIN);
	//Enable Pin Change IRQ MASK
	PCMSK2 |= (1<<PCINT18);
	//Enable Pin Change Interrupt PORTD
	if( !(PCICR&(1<<PCIE2)) )PCICR |= (1<<PCIE2);
}

uint8_t GetBrightKey()
{
	return (PIND&(1<<BRIGHT_KEY_PIN));
}

uint16_t GetBrightness()
{
	return brightness;
}

void SetBrightness(uint16_t value)
{
	brightness=value;
}


void Mode_Key_Init()
{
	//Switch Pin to input
	MODE_KEY_PORT_DIR &= ~(1<<MODE_KEY_PIN);
	//Set Port High to enable Pullup (PUD must be enabled in MCUCR) !!!!
	MODE_KEY_PORT |= (1<<MODE_KEY_PIN);
	//Enable Pin Change IRQ MASK
	PCMSK2 |= (1<<PCINT20);
	//Enable Pin Change Interrupt PORTD
	if( !(PCICR&(1<<PCIE2)) )PCICR |= (1<<PCIE2);
}

uint8_t GetModeKey()
{
	return (PIND&(1<<MODE_KEY_PIN));
	
}

uint8_t GetMode()
{
	return mode;
}

void SetMode(uint8_t value)
{
	mode=value;
}

uint8_t GetSetupMode()
{
	return Setup_mode;
}

//Vector for PORTD Pins
ISR(PCINT2_vect)
{
	if( !(PIND & (1<<BRIGHT_KEY_PIN)) && (tim1_brightness_debounce==1) ) 
	{
		tim1_brightness_debounce=0;
	}
	
	if ( !(PIND & (1<<MODE_KEY_PIN)) && (tim1_mode_debounce==1))
	{
		 //mode++;
		 //if (mode > 13) mode =4;
		 tim1_mode_debounce=0;

	}		 
	
}