/*
 * Timer.h
 *
 * Created: 21.07.2012 14:53:01
 *  Author: admin
 */ 


#ifndef TIMER_H_
#define TIMER_H_
#include <avr/io.h>
#include <avr/interrupt.h>

extern volatile uint8_t tim1_irq;
extern volatile uint8_t tim1_mode_debounce;
extern volatile uint8_t tim1_brightness_debounce;
extern volatile uint8_t tim1_delay_done;
extern volatile uint8_t tim1_delay;
extern volatile uint8_t tim1_auto_delay;

#define TIM1_MAX_DELAY 20
#define TIM1_MAX_AUTO_DELAY 255
#define TIM1_MAX_AUTO_DELAY_INC 5
#define TIM1_MIN_DELAY 1


union {
	uint16_t as_u16;
	uint8_t as_u8[2];
} adc_result;
	
typedef enum{
	eTimer0_PRESCALER_0 = (0<<CS02)|(0<<CS01)|(0<<CS00),
	eTimer0_PRESCALER_1 = (0<<CS02)|(0<<CS01)|(1<<CS00),
	eTimer0_PRESCALER_8 = (0<<CS02)|(1<<CS01)|(0<<CS00),
	eTimer0_PRESCALER_64 = (0<<CS02)|(1<<CS01)|(1<<CS00),
	eTimer0_PRESCALER_256 = (1<<CS02)|(0<<CS01)|(0<<CS00),
	eTimer0_PRESCALER_1024 = (1<<CS02)|(0<<CS01)|(1<<CS00),
	eTimer0_PRESCALER_ExtT0fallingEdge = (1<<CS02)|(1<<CS01)|(0<<CS00),
	eTimer0_PRESCALER_ExtT0risingEdge = (1<<CS02)|(1<<CS01)|(1<<CS00)
} eTimer0_PRESCALER;

typedef enum{
	eTimer0_Frequence_4KHz = 4000,
	eTimer0_Frequence_8KHz = 8000
} eTimer0_Frequence;

typedef enum{
	eTimer1_Frequence_100Hz=1,
	eTimer1_Frequence_50Hz=2,
	eTimer1_Frequence_20Hz=3,
	eTimer1_Frequence_10Hz=4,
	eTimer1_Frequence_4Hz=5,
	eTimer1_Frequence_2Hz=6,
	eTimer1_Frequence_1Hz = 7,
	eTimer1_Frequence_0k5Hz = 8,
	eTimer1_Frequence_0k33Hz = 9,
	eTimer1_Frequence_0k25Hz = 10
} eTimer1_Frequence;

void Timer0_Init();
void Timer0_Start();
void Timer0_Start(eTimer0_Frequence frequence);
void Timer0_Stop();
void Timer1_Init();
void Timer1_Start(eTimer1_Frequence frequence);
void Timer1_Stop();

void Timer1_Delay(uint8_t value);
void Timer1_IRQ_Delay();



#endif /* TIMER_H_ */