/*
 * UART.h
 *
 * Created: 20.10.2012 11:19:31
 *  Author: admin
 */ 


#ifndef UART_H_
#define UART_H_

#include <avr/io.h>

#define UART0_DATA UDR0      //UART Data Register
#define UART0_STATUS UCSR0A  //UART Status register

#define F_CPU1 16000000UL
#define BAUDRATE (9600)//(250000)//(76800)
#define BAUD_PRESCALLER (((F_CPU1/(BAUDRATE*16UL)))-1)
#define UART_STARTTOKEN 0xAA
#define UART_MAX_DATA 11

#define RX_BUFFER_SIZE 100
#define TX_BUFFER_SIZE 100
#define TX_BUFFER_EMPTY     0
#define TX_BUFFER_LASTBYTE  1
#define TX_BUFFER_FULL      2
#define TX_BUFFER_NOT_EMPTY 3

typedef enum {eTX_BUFFER_EMPTY=0,
eTX_BUFFER_LASTBYTE=1,
eTX_BUFFER_FULL = 2,
eTX_BUFFER_NOT_EMPTY=3
			  } eTX_BUFFER_STATE;



extern volatile char UART_FrameFinished;
extern volatile char UART_FrameBuffer[20];

void UART_Init(void);
void UART_Disable();
uint8_t UART_Check(void);
void UART_WriteTxBuffer(char Byte);
char UART_ReadTxBuffer();
void UART_SendByte(char Byte);
void UART_SendString(char *pString);
uint8_t UART_GetBufferFill();

void USART_init1(uint16_t baudrate);
unsigned char USART_receive(void);
void USART_send( unsigned char data);
void USART_putstring(char* StringPtr);


#endif /* UART_H_ */